<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>Blockly Demo: Generating Luna8266</title>
  <script src="../blockly/dist/blockly_compressed.js"></script>
  <script src="../blockly/dist/blocks_compressed.js"></script>
  <script src="../blockly/dist/lua_compressed.js"></script>
  <script src="../catalejo-oursblockly/targets/luna8266/dist/luna8266/luna8266.js"></script>
  <script src="../catalejo-oursblockly/targets/luna8266/dist/luna8266/toolbox.js"></script>
  <!-- <script src="../../blockly/msg/js/en.js"></script> -->
  <script src="../blockly/build/msg/es.js"></script>
  <!-- <script src="../../blockly/build/msg/en.js"></script> -->
  <!-- <script src="https://unpkg.com/@blockly/plugin-typed-variable-modal@3.1.15/dist/index.js"></script> -->
  <script src="https://unpkg.com/@blockly/plugin-typed-variable-modal@5.0.6/dist/index.js"></script>
  <style>
    body {
      background-color: #fff;
      font-family: sans-serif;
    }
    h1 {
      font-weight: normal;
      font-size: 140%;
    }
  </style>
</head>
<body>
  <h4><a href="https://developers.google.com/blockly/">Blockly</a> &gt;
    <a href="../index.html">Demos</a> &gt; Generating Luna8266</h4>


  <p>&rarr; More info on <a href="https://developers.google.com/blockly/guides/configure/web/code-generators">Code Generators</a> and <a href="https://developers.google.com/blockly/guides/app-integration/running-javascript">Running Luna8266</a>.</p>

  <p>
    <button onclick="showCode()">Show Luna8266</button>
    <button onclick="runCode()">Run Luna8266</button>
  </p>

  <div id="blocklyDiv" style="height: 600px; width: 1000px;"></div>

  <!-- Empezar el area de trabajo limpia -->
  <xml xmlns="https://developers.google.com/blockly/xml" id="startBlocks" style="display: none">
  </xml>

  <script>
    var demoWorkspace = Blockly.inject('blocklyDiv',
        {
          media: '../blockly/media/',
          toolbox: luna8266Toolbox
        });
    /* var demoWorkspace = Blockly.inject('blocklyDiv',
        {
          media: '../blockly/media/',
          toolbox: document.getElementById('toolbox')
        }); */
    Blockly.Xml.domToWorkspace(document.getElementById('startBlocks'),
                               demoWorkspace);
    const createFlyout = function(workspace) {
      let xmlList = [];
      // Add your button and give it a callback name.
      const button = document.createElement('button');
      button.setAttribute('text', 'Create Typed Variable');
      button.setAttribute('callbackKey', 'callbackName');

      xmlList.push(button);

      // This gets all the variables that the user creates and adds them to the
      // flyout.
      const blockList = Blockly.VariablesDynamic.flyoutCategoryBlocks(workspace);
      xmlList = xmlList.concat(blockList);
      return xmlList;
    };

    demoWorkspace.registerToolboxCategoryCallback('CREATE_TYPED_VARIABLE', createFlyout);
    const typedVarModal = new TypedVariableModal(
      demoWorkspace, 'callbackName',
      [
        ["Entero", "int"],
        ["Flotante", "float"],
        ["Texto", "string"],
        ["Duración", "dur"],
        ["Lista", "array"]
      ]);
    typedVarModal.init();

    const createFlyout1 = function(workspace) {
      let xmlList1 = [];
      // Add your button and give it a callback name.
      const button = document.createElement('button');
      button.setAttribute('text', 'Create Oscilador');
      button.setAttribute('callbackKey', 'callbackName1');

      xmlList1.push(button);

      // This gets all the variables that the user creates and adds them to the
      // flyout.
      const blockList1 = Blockly.VariablesDynamic.flyoutCategoryBlocks(workspace);
      xmlList1 = xmlList1.concat(blockList1);
      return xmlList1;
    };

    demoWorkspace.registerToolboxCategoryCallback('CREATE_TYPED_VARIABLE1', createFlyout1);
    const typedVarModal1 = new TypedVariableModal(
      demoWorkspace, 'callbackName1', 
      [
        ["Oscilador Seno", "SinOsc"],
        ["Oscilador Triangular", "TriOsc"],
        ["Oscilador de pulso", "PulseOsc"],
        ["Oscilador de sierra", "SawOsc"],
        ["Oscilador cuadrado", "SqrOsc"],
      ]);
    typedVarModal1.init();

    const createFlyoutInstrument = function(workspace) {
      let xmlListInstrument = [];
      // Add your button and give it a callback name.
      const button = document.createElement('button');
      button.setAttribute('text', 'Crear instrumento');
      button.setAttribute('callbackKey', 'callbackNameInstrument');

      xmlListInstrument.push(button);

      // This gets all the variables that the user creates and adds them to the
      // flyout.
      const blockListInstrument = Blockly.VariablesDynamic.flyoutCategoryBlocks(workspace);
      xmlListInstrument = xmlListInstrument.concat(blockListInstrument);
      return xmlListInstrument;
    };

    demoWorkspace.registerToolboxCategoryCallback('CREATE_TYPED_VARIABLE_INSTRUMENT', createFlyoutInstrument);
    const typedVarModalInstrument = new TypedVariableModal(
      demoWorkspace, 'callbackNameInstrument',
      [
        ["Piano", "Rhodey"],
        ["Clarinete", "Clarinet"],
        ["Archivo", "SndBuf"],
      ]);
    typedVarModalInstrument.init();

    const createFlyoutCommunication = function(workspace) {
      let xmlListCommunication = [];
      // Add your button and give it a callback name.
      const button = document.createElement('button');
      button.setAttribute('text', 'Crear comunicación');
      button.setAttribute('callbackKey', 'callbackNameCommunication');

      xmlListCommunication.push(button);

      // This gets all the variables that the user creates and adds them to the
      // flyout.
      const blockListCommunication = Blockly.VariablesDynamic.flyoutCategoryBlocks(workspace);
      xmlListCommunication = xmlListCommunication.concat(blockListCommunication);
      return xmlListCommunication;
    };

    demoWorkspace.registerToolboxCategoryCallback('CREATE_TYPED_VARIABLE_COMMUNICATION', createFlyoutCommunication);
    const typedVarModalCommunication = new TypedVariableModal(
      demoWorkspace, 'callbackNameCommunication',
      [
        ["OSC enviar", "OscOut"],
        ["OSC recibir", "OscIn"],
        ["OSC mensaje", "OscMsg"],
        ["MIDI enviar", "MidiOut"],
        ["MIDI recibir", "MidiIn"],
        ["MIDI mensaje", "MidiMsg"],
        ["Serial", "SerialIO"],
      ]);
    typedVarModalCommunication.init();

    function showCode() {
      // Generate ChucK code and display it.
      Blockly.Lua.INFINITE_LOOP_TRAP = null;
      var code = Blockly.Lua.workspaceToCode(demoWorkspace);
      console.log(code);
      alert(code);
    }

    function runCode() {
      // Generate ChucK code and run it.
      window.LoopTrap = 1000;
      Blockly.Lua.INFINITE_LOOP_TRAP = 
          'if (--window.LoopTrap == 0) throw "Infinite loop.";\n';
      var code = Blockly.Lua.workspaceToCode(demoWorkspace);
      Blockly.Lua.INFINITE_LOOP_TRAP = null;
      try {
        eval(code);
      } catch (e) {
        alert(e);
      }
    }
  </script>

</body>
</html>
